<?php
/**
 * disAllow
 *
 * @version 1.0.8
 * @package disAllow
 * @author ZyX (Micriucov Oleg)
 * @copyright (C) 2010 by ZyX (http://www.allforjoomla.ru)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 *
 * If you fork this to create your own project,
 * please make a reference to allforjoomla.com someplace in your code
 * and provide a link to http://www.allforjoomla.ru
 **/
defined( '_JEXEC' ) or die( ':)' );

class  plgSystemDisallow extends JPlugin{
	
	function plgSystemDisallow(& $subject, $config){
		parent::__construct($subject, $config);
	}
	
	function onAfterRender(){
		$mainframe = & JFactory::getApplication('site');
		if($mainframe->isAdmin()) return true;
		$task = JRequest::getCmd('task','');
		if($task=='edit') return;
		$body = JResponse::getBody();
		if(!$body||$body=='') return true;
		if(JString::strpos( $body, 'href=' ) === false ) return true;
		$hasAllows = false;
		$strpA1 = strpos($body,'<allow>');
		$strpA2 = strpos($body,'</allow>');
		if($strpA1&&$strpA2&&$strpA1<$strpA2) $hasAllows = true;
		if($hasAllows) $body = preg_replace("/<allow>(.*?)(?=<\/allow>)<\/allow>/sie","'<allow>'.base64_encode('\\1').'</allow>'",$body);
		$body = preg_replace_callback('/<a(.*?)(?=<\/a>)<\/a>/i', 'plgDisallowCB', $body);
		if($hasAllows) $body = preg_replace("/<allow>(.*?)(?=<\/allow>)<\/allow>/sie",'stripslashes(base64_decode("\\1"))',$body);
		JResponse::setBody($body);
	}
	
	function onAfterDispatch(){
		$mainframe = & JFactory::getApplication('site');
		if($mainframe->isAdmin()) return true;	
		$task = JRequest::getCmd('task','');
		if($task=='edit') return;
		$exDomainsTxt = $this->params->get('exDomains', '');
		$exDomains = array();
		$tmp = explode(',',$exDomainsTxt);
		if(is_array($tmp)){
			foreach($tmp as $host){
				$host = trim($host);
				if($host!='') $exDomains[] = $host;
			}
		}
		$GLOBALS['plgSystemDisallowDomains'] = $exDomains;
		$hst = str_replace('www.','',$_SERVER['HTTP_HOST']);
		$GLOBALS['plgSystemDisallowDomains'][] = $hst;
		$GLOBALS['plgSystemDisallowDomains'][] = 'www.'.$hst;
	}

	function isInternalLink($url){
		if(is_null($url)||$url==''||substr($url,0,1)=='/'||substr($url,0,10)=='javascript') return true;
		else if(preg_match('~allforjoomla\.ru~i',$url)) return true;
		$URI = parse_url($url);
		$host = $URI['host'];
		foreach($GLOBALS['plgSystemDisallowDomains'] as $allowDomain){
			$reg = str_replace('.','\.',$allowDomain);
			if(strpos($reg,'*\.')!==false) $reg = str_replace('*\.','([^\.]+\.)?',$reg);
			$reg = str_replace('*','',$reg);
			$reg = '/^'.$reg.'$/iu';
			if(preg_match($reg,$host)) return true;
		}
		$URI =& JURI::getInstance();
		if($URI->isInternal($url)) return true;
		return false;
	}
}

function plgDisallowCB($matches){
	preg_match('/href=[\'"]?([^"\' ]+)/i',$matches[0],$matchURL);
	if(!plgSystemDisallow::isInternalLink($matchURL[1])){
		$result = $matches[0];
		if(!strpos($result,'nofollow')) $result = str_replace('href=','rel="nofollow" href=',$result);
		if(!strpos($result,'_blank')) $result = str_replace('href=','target="_blank" href=',$result);
		$result = '<!--noindex-->'.$result.'<!--/noindex-->';
		return $result;
	}
	return $matches[0];
}
